//
// TAReadFile reads ascii file TAAlign.txt with OTR alignment constants
// 
// usage: TAReadFile("myfilename",prtflg) or TAReadFile(), default see below
//        int prtflg=1 print modul offsets
//
// DK 27.1.00
//

#include <iostream.h>
#include <fstream.h>
#include <string>

extern "C" int TAChaGEDE(const char*,float,float,float,float,float,float,int);

void TAReadFile(char* filename,int prtflg){

  ifstream in;
  in.open(filename,ios::in); 

  if(!in){cout<<"TAReadFile: Can't find "<<filename<<endl;
     return;
  } else 
     cout<<"TAReadFile: Reading "<<filename<<endl;

  bool first(true);
  float dx,dy,dz,da,db,dc;
  string name;
  while(in>>name){
      if(name.at(0)=='*'){
           char buf[100];
           in.getline(buf,100);
      }else{
           if(!(in>>dx>>dy>>dz>>da>>db>>dc))
                    cout<<"TAReadFile: reading error at "<<name
                        <<" <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< "<<endl;
      }
      if(TAChaGEDE(name.c_str(),dx,dy,dz,da,db,dc,prtflg)) {
         if(first) {
            cout<<"TAReadFile: OTR GEDE tables modified!"<<endl;
            first=false;
         }
      } else cout<<"TAReadFile: could not change "<<name<<endl;
  }
  in.close();
  
}
