#ifndef _RSEG_cmp_hh_
#define _RSEG_cmp_hh_

/* Least significant bits indicate LOGICAL function of detector part */
/* Most significant bits  indicate hardware type of detector part    */
/* Example: segments with SI08 hits have hardware bit Rsegc::sil     */
/*                                    and logical bit Rsegc::magt set*/


struct Rsegc
{
  enum Cmp {
    vxd     =        0x1, /* Vertex Detector */
    patt    =        0x2, /* Pattern Tracker*/
    magt    =        0x4, /* Magnet Tracker*/
    muon    =        0x8, /* Muon Detector*/
    ecal    =       0x10, /* Ecal*/
    tar     =       0x20, /* Target Constraint*/
    
    trit    =       0x40, /* Trigger Tracker, betw RICH and ECAL */
    bit7    =       0x80, /* not assigned yet =first bit is bit0,*/
    bit8    =      0x100, /* not assigned yet =first bit is bit0,*/
    bit9    =      0x200, /* not assigned yet =first bit is bit0,*/
    bit10   =      0x400, /* not assigned yet =first bit is bit0,*/
    bit11   =      0x800, /* not assigned yet =first bit is bit0,*/
    bit12   =     0x1000, /* not assigned yet =first bit is bit0,*/
    bit13   =     0x2000, /* not assigned yet =first bit is bit0,*/
    bit14   =     0x4000, /* not assigned yet =first bit is bit0,*/
    bit15   =     0x8000, /* not assigned yet =first bit is bit0,*/
    bit16   =    0x10000, /* not assigned yet =first bit is bit0,*/
    bit17   =    0x20000, /* not assigned yet =first bit is bit0,*/
    bit18   =    0x40000, /* not assigned yet =first bit is bit0,*/
    bit19   =    0x80000, /* not assigned yet =first bit is bit0,*/
    bit20   =   0x100000, /* not assigned yet =first bit is bit0,*/
    bit21   =   0x200000, /* not assigned yet =first bit is bit0,*/
    bit22   =   0x400000, /* not assigned yet =first bit is bit0,*/
    bit23   =   0x800000, /* not assigned yet =first bit is bit0,*/

    slt     =  0x1000000, /* SLT seeded segment */
    trd     =  0x2000000, /* TRD straw device type*/
    rich    =  0x4000000, /* Cherenkov Counter device type*/
    ptc     =  0x8000000, /* HiPT Chamber device type*/
    msg     = 0x10000000, /* MSGC device type*/
    wch     = 0x20000000, /* honeycomb wire chamber device type*/
    sil     = 0x40000000, /* silicon strip device type*/
    bitsign = 0x80000000  /* Kill bit, set if segment is deleted */
  };
};


#endif
