*-- Author :    Hartwig Albrecht   04/04/95

      SUBROUTINE MMBWRK (JL, NNR, NNC, NNE)

************************************************************************
*
* Description: Book working table for NR rows.
*              An existing table will be overwritten.
*              Extensions of working tables: use MMBOOK.
*
* Called from: anywhere
*
* External references: MZLIFT, MZPUSH
*
* Argument in/out description
*  JL      in/out link
*  NR      in     see above
*  NC      in     number of columns / row
*  NE      in     extension: book table in units of NE rows
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"

      INTEGER JL(*), NR, NC, NE, NNR(*), NNC(*), NNE(*), LOCF, I, IL,
     +  MZBUF(5)
      CHARACTER CNAME*4
      DATA MZBUF /5 * 0/

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

      NR = NNR(1)
      NC = NNC(1)
      NE = NNE(1)

      IL = LOCF (JL) - LARLN1

C check if JL is a correct Zebra link

      IF (IL .LE. 0 .OR. IL .GT. NARLNK)  GO TO 270

C check positivity of  number of rows / columns

      IF (NC .LE. 0 .OR. NR .LT. 0)  GO TO 260

C check that JL is a stand-alone table

      IF (IMEMO_SUP(1,IL) .GT. 0 .OR. IMEMO_SUP(2,IL) .GT. 0)
     +  GO TO 250
      IQ(IQMEMO_BOOK(IL)) = IQ(IQMEMO_BOOK(IL)) + 1

      MZBUF(1) = HMEMO_NAME(1,IL)
      MZBUF(5) = IMEMO_FMT(IL)
      IF (JL(1) .EQ. 0)  THEN

C book a new bank

        MZBUF(4) = 2 + NC * (NR + NE)
        CALL MZLIFT (IMEMO_DIV(IL), JL(1), 0, 2, MZBUF, 0)

      ELSE

C bank exists already:

C set content of free rows to 0

        DO 10 I = 3, MIN (IQ(JL(1)-1), 2 + NC * (NR + NE))
          IQ(JL(1)+I) = 0
 10     CONTINUE

C extend table

        CALL MZPUSH (IMEMO_DIV(IL), JL(1), 0,
     +    2 - IQ(JL(1)-1) + NC * (NR + NE), ' ')

      END IF

      IQ(IQMEMO_OCOL(IL)) = NC
      IQ(IQMEMO_COL(IL)) = NC
      IQ(IQMEMO_EXT(IL)) = NE
      IQ(JL(1)+1) = NC
      IQ(JL(1)+2) = NR
      GO TO 290

 250  C78 = 'MMBWRK:'
      CALL CHHTOC (IQ(HQMEMO_NAME(1,IL)), CNAME)
      CALL CH78BC (CNAME)
      CALL CH78BC ('is not a stand-alone table (no working space)')
      CALL ME78ER
      GO TO 290

 260  C78 = 'MMBWRK: table'
      CALL CHHTOC (IQ(HQMEMO_NAME(1,IL)), CNAME)
      CALL CH78BC (CNAME)
      CALL CH78BC ('has non-positive number of columns or rows')
      CALL ME78ER
      GO TO 290

 270  CALL MEERRO ('MMBWRK: link JL not inside link area')

 290  END

************************************************************************
* End of MMBWRK
************************************************************************
