//                              -*- Mode: C++ -*-
//: CmdCareLambda.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
/* $Log: CmdCareLambda.C,v $
 * Revision 1.3  1999/08/04 15:21:30  natasha
 * new care version from Mauro
 *
 * Revision 1.2  1999/06/01  16:07:31  villa
 * before HH
 *
 */
//

#include "care/CmdCareLambda.hh"
#include "care/ESCorCOGPos.hh"


/////////////// The function seen by kuip

#ifdef USEKUIP
extern "C" {
  void carelambda_(){
    CmdCareLambda lamCmd;
    lamCmd.readAndExe();
  }
}; // end of extern
#endif
//////////////////////////////////////////////////////////

/*
CLASS
  CmdCareLambda
  Base class to deal with the Lambda kuip command
*/

CmdCareLambda::CmdCareLambda() : subcal(Inner) , lambda(4.075) {}

CmdCareLambda::~CmdCareLambda(){}

void CmdCareLambda::defValues(){
  subcal = Inner;
  lambda = 4.075;
}

//--
//   Execute stored command
void CmdCareLambda::execute(){
  ESCorCOGPos::fill(subcal, lambda);
}

#ifdef USEKUIP
//--
//   Read a command from external
void CmdCareLambda::read(){
  subcal = (SubCal) readInt();
  lambda = readFloat();
  if(!(subcal>=Inner && subcal<=Outer)){
    defValues();
  }
}
#endif
                          
//--
//   Printout Information for the current lambda info stored
void CmdCareLambda::dump(){
   ESCorCOGPos::dump();
}


