
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Declaration of Histograms and Initialization
//
// changes:
// 28 Oct 1999 (AG) use defines from DQ.h
// 06 Dec 1999 (CP) add trigger codes 9
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_CORR.h"

//
// function code
//
int
DQ_CORR_hit_init()
{
//======================================================================
//          Synchronization histograms
//======================================================================
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,12),"CORR: Hits in OTR vs Hits in SVD", 50,0,400,50,0,500);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,14),"CORR: Hits in HigPt vs Hits in SVD", 50,0,400,150,0,300);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,15),"CORR: Hits in RICH vs Hits in SVD", 50,0,400,50,0,2000);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,16),"CORR: Hits in TRD vs Hits in SVD", 50,0,400,20,0,20);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,17),"CORR: Hits in ECAL vs Hits in SVD", 50,0,400,50,0,1000);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,18),"CORR: Hits in MUON vs Hits in SVD", 50,0,400,50,0,4000);
 
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,24),"CORR: Hits in HighPt vs Hits in OTR", 50,0,500,150,0,300);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,25),"CORR: Hits in RICH vs Hits in OTR", 50,0,500,50,0,2000);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,26),"CORR: Hits in TRD vs Hits in OTR", 50,0,500,20,0,20);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,27),"CORR: Hits in ECAL vs Hits in OTR", 50,0,500,50,0,1000);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,28),"CORR: Hits in MUON vs Hits in OTR", 50,0,500,50,0,4000);
 
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,45),"CORR: Hits in RICH vs Hits in HighPt", 150,0,300,50,0,2000);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,46),"CORR: Hits in TRD vs Hits in HighPt", 150,0,300,20,0,20);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,47),"CORR: Hits in ECAL vs Hits in HighPt", 150,0,300,50,0,1000);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,48),"CORR: Hits in MUON vs Hits in HighPt", 150,0,300,50,0,4000);
 
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,56),"CORR: Hits in TRD vs Hits in RICH", 50,0,2000,20,0,20);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,57),"CORR: Hits in ECAL vs Hits in RICH", 50,0,2000,50,0,1000);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,58),"CORR: Hits in MUON vs Hits in RICH", 50,0,2000,50,0,4000);;
 
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,67),"CORR: Hits in ECAL vs Hits in TRD", 20,0,20,50,0,1000);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,68),"CORR: Hits in MUON vs Hits in TRD", 20,0,20,50,0,4000);
 
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,78),"CORR: Hits in MUON vs Hits in ECAL", 50,0,1000,50,0,4000);
 
//======================================================================
//          BX histograms
//======================================================================
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,100),"CORR: (TC: 0) BX number distribution",222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,101),"CORR: (TC: 0) SVD hits in BX",222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,102),"CORR: (TC: 0) OTR hits in BX",222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,104),"CORR: (TC: 0) High Pt hits in BX",222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,105),"CORR: (TC: 0) RICH hits in BX",222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,106),"CORR: (TC: 0) TRD hits in BX",222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,107),"CORR: (TC: 0) ECAL hits in BX",222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,108),"CORR: (TC: 0) MUON hits in BX",222,-0.5,221.5);

 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,150),"CORR: (TC: 9) BX number distribution",222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,151),"CORR: (TC: 9) SVD hits in BX",222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,152),"CORR: (TC: 9) OTR hits in BX",222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,154),"CORR: (TC: 9) High Pt hits in BX",222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,155),"CORR: (TC: 9) RICH hits in BX",222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,156),"CORR: (TC: 9) TRD hits in BX",222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,157),"CORR: (TC: 9) ECAL hits in BX",222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,158),"CORR: (TC: 9) MUON hits in BX",222,-0.5,221.5);

//-------------------------------------------------------------------------
//  run-number
//-------------------------------------------------------------------------

 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,201),"CORR: run number",30000,1000.5,31000.5); 
 
  return 0; // return error code (0 = okay)
}
