
/******************************************************************* 
 *
 * D. Samtleben 10 Aug 1999
 * A. Gellrich
 *
 * Filling of histograms
 *
 * hints:
 *        components: COMP_SVD
 *                    COMP_ITR
 *                    COMP_HIPT
 *                    COMP_OTR
 *                    COMP_RICH
 *                    COMP_TRD
 *                    COMP_ECAL
 *                    COMP_MUON
 *                    COMP_FLT
 *                    COMP_SLT
 *                    COMP_TLT
 *                    COMP_FARM
 *
 *         levels:    LVL_RAW
 *                    LVL_HIT
 *                    LVL_REC
 *                         
 * changes:                
 * 22 Oct 1999 (AG) code polishing
 * 27 Oct 1999 (AG) use defines from DQ.h
 *  1 Nov 1999 (AG) get rid of dq_hid.h
 *                                       
 *******************************************************************/

/* standard includes */
#include <stdlib.h>
#include <stdio.h>

/* ONLINE includes */
#include "rhp.h"
#include "event.h"

/* Arte includes */
#include "dq/DQ.h"
#include "dq/DQ_HIPT.h"

/*               */
/* function code */
/*               */
int
DQ_HIPT_raw_evnt( EVENT_HDR *event )
{
  unsigned int histogram_id1 = 1;     /* lowest */
  unsigned int histogram_id2 = 65535; /* highest */

  float x_value = 0; /* containing the x-value to be histogrammed */
  float y_value = 0; /* containing the y-value to be histogrammed */
  
  /* 1-dim histogram */
  rhp_hf1( DQ_ID( COMP_HIPT, LVL_RAW, histogram_id1 ), 
	   x_value, 1 );
  
  /* 2-dim histogfram */
  rhp_hfill( DQ_ID( COMP_HIPT, LVL_RAW, histogram_id2 ),
	     x_value, y_value, 1 );

  return 0; /* return error code (0 = okay) */
}
