
// ********************************************************************
//
// Routine:      DQ_RECO_JPSIKvertex
// Author:       D.Dujmic
//
// Description:  fill JPsiK  DQ histograms
//
// Changes:
//
// ********************************************************************

// standrad includes
#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include <algo.h>

// ARTE includes
#include "arte/RSEG_cmp.hh"
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "rhp.h" 
#include "dq/DQ.h"

int DQ_RECO_rcXB_init();

//
// function code
//
int
DQ_RECO_JPSIKvertex_init()
{
  // show up
  ARTE_mark( "DQ_RECO_JPSIKvertex_init 0", 0 );

  DQ_RECO_rcXB_init();      // id=1000 ... 1021

  // show up
  ARTE_mark( "DQ_RECO_JPSIKvertex_init 1", 0 );

  return 0;
}

//
// quality histograms for B selection
//
int DQ_RECO_rcXB_init() {
  rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 1000 ), "B selection: efficiency",                5, -0.5,  4.5 );
  rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 1001 ), "B selection: prongs per vertex",        15, -0.5, 14.5 );
  rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 1002 ), "B selection: vertex chi2, J/Psi",       45,    0,   15 ); 
  rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 1003 ), "B selection: vertex chi2, all prongs",  45,    0,   15 );  
  rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 1004 ), "B selection: vertex chi2, select.",     45,    0,   15 ); 
  rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 1005 ), "B selection: vertex z, select. J/Psi", 100,  -15,   15 ); 
  rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 1006 ), "B selection: vertex z, select. fit",   100,  -15,   15 ); 
  rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 1011 ), "B selection: vertex z, J/Psi w/ prong",100,  -15,   15 ); 
  rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 1014 ), "B selection: decay length from wire",   50,   -1,    5 ); 
  rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 1015 ), "B selection: decay wire z",             50,   -6,    0 ); 
  rhp_hbook2( DQ_ID( COMP_RECO,LVL_REC, 1016 ), "B selection: decay wire x y",           50,-1,1,50,-1,1); 
  rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 1018 ), "B selection: J/Psi candidates",         20,  -.5, 19.5 ); 
  rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 1019 ), "B selection: prong candidates",        100,  -.5, 99.5 ); 
  rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 1021 ), "B selection: kaons per vertex",         15, -0.5, 14.5 );
  
  return 0;
}

