 
// *****************************************************************************
//
// source:    DQ_RECO_JPSIMM.C
//
// type:      source code
//
// created:   26 Jun 2000
//
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// called by: DQ_event()
//
// changes:
//  5 Jul 2000 (AG) creation
//  7 Jul 2000 (AG) polished printout
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_RECO.h"

// externals
extern float massJPSIMM;

//
// function code
//
int
DQ_RECO_JPSIMM_init()
{
  // show up
  ARTE_mark( "DQ_RECO_JPSIMM_init 0", 0 );
  cout << "DQ_RECO_JPSIMM_init" << endl;

  rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 150 ), "RECO JPSIMM candidates", 40, 0, 5 );

  // show up
  ARTE_mark( "DQ_RECO_JPSIMM_init 1", 0 );

  return 0;
}

//
// function call
//
int
DQ_RECO_JPSIMM_evnt()
{
  // show up
  ARTE_mark( "DQ_RECO_JPSIMM_evnt 0", 0 );
  
  if( massJPSIMM > 0 ) rhp_hf1( DQ_ID( COMP_RECO,LVL_REC, 150 ), massJPSIMM, 1 );
  
  // show up
  ARTE_mark( "DQ_RECO_JPSIMM_evnt 1", 0 );

  return 0; // return error code (0 = okay)
}
