        subroutine otrvol
******************************************************************
* Defines GEANT volumes for the OTR chambers.
*
* Called from OTRGEO
*
* External references: CRVOLU
*
* Author: Alexander Lanyov     Feb 1999
*                      updated Oct 2000 (elimination of ZGOTR.fi)
******************************************************************
        implicit none

#include "gean/ZGESL.fi"
#include "gean/otrgeo.fi"

        integer cmp
        character*4 shap
c------------------------------------------------ volumes with shape PARA
c  For volume WTL1 xms = 1191.81
c  For volume WTL2 xms = 636.1
c  For volume WTL3 xms = 636.1
c  For volume WTL4 xms = 1245.28
c  For volume WTL5 xms = 665.91
c  For volume WTL6 xms = 665.91
c  For volume WTL7 xms = 1191.81
c  For volume WTL8 xms = 636.1
c  For volume WTL9 xms = 636.1
c  For volume WL10 xms = 1245.28
c  For volume WL11 xms = 665.91
c  For volume WL12 xms = 665.91

         CMP = LGESL_WCH
         shap = 'PARA'

c-- 1. 10 mm single layer sensitive

        CALL UCTOH('WTL1',WTDT(1),4,4)
        CALL CRVOLU('WTL1',SHAP,CMP,3,'OTR_WS10',2,1)
c                   Volnam Shap CmpMedflg Mat   Col Seen ivol*

c-- 2. 5 mm single layer sensitive
        CALL UCTOH('WTL2',WTDT(2),4,4)
        CALL CRVOLU('WTL2',SHAP,CMP,3,'OTR_WS5',2,1)

c-- 3. 5 mm single layer nonsensitive
        CALL UCTOH('WTL3',WTDT(3),4,4)
        CALL CRVOLU('WTL3',SHAP,CMP,1,'OTR_WS5',5,1)

c-- 4. 10 mm double layer sensitive
        CALL UCTOH('WTL4',WTDT(4),4,4)
        CALL CRVOLU('WTL4',SHAP,CMP,3,'OTR_WD10',6,1)

c-- 5. 5 mm  double layer sensitive
        CALL UCTOH('WTL5',WTDT(5),4,4)
        CALL CRVOLU('WTL5',SHAP,CMP,3,'OTR_WD5',6,1)

c-- 6. 5 mm double layer nonsensitive
        CALL UCTOH('WTL6',WTDT(6),4,4)
        CALL CRVOLU('WTL6',SHAP,CMP,1,'OTR_WD5',3,1)

c-- 7. 10 mm single layer sensitive in magnetic field
        CALL UCTOH('WTL7',WTDT(7),4,4)
        CALL CRVOLU('WTL7',SHAP,CMP,4,'OTR_WS10',2,1)

c-- 8. 5 mm single layer sensitive in magnetic field
        CALL UCTOH('WTL8',WTDT(8),4,4)
        CALL CRVOLU('WTL8',SHAP,CMP,4,'OTR_WS5',2,1)

c-- 9. 5 mm single layer nonsensitive in magnetic field
        CALL UCTOH('WTL9',WTDT(9),4,4)
        CALL CRVOLU('WTL9',SHAP,CMP,2,'OTR_WS5',3,1)

c--10. 10 mm double layer sensitive in magnetic field
        CALL UCTOH('WL10',WTDT(10),4,4)
        CALL CRVOLU('WL10',SHAP,CMP,4,'OTR_WD10',3,1)

c--11. 5 mm  double layer sensitive in magnetic field
        CALL UCTOH('WL11',WTDT(11),4,4)
        CALL CRVOLU('WL11',SHAP,CMP,4,'OTR_WD5',2,1)

c--12. 5 mm double layer nonsensitive in magnetic field
        CALL UCTOH('WL12',WTDT(12),4,4)
        CALL CRVOLU('WL12',SHAP,CMP,2,'OTR_WD5',2,1)

c---------------------------------- The same for shape TRD1
         shap = 'TRD1'

c--13. 10 mm single layer sensitive
        CALL UCTOH('WL13',WTDT(13),4,4)
        CALL CRVOLU('WL13',SHAP,CMP,3,'OTR_WS10',2,1)

c--14. 5 mm single layer sensitive
        CALL UCTOH('WL14',WTDT(14),4,4)
        CALL CRVOLU('WL14',SHAP,CMP,3,'OTR_WS5',2,1)

c--15. 5 mm single layer nonsensitive
        CALL UCTOH('WL15',WTDT(15),4,4)
        CALL CRVOLU('WL15',SHAP,CMP,1,'OTR_WS5',5,1)

c--16. 10 mm double layer sensitive
        CALL UCTOH('WL16',WTDT(16),4,4)
        CALL CRVOLU('WL16',SHAP,CMP,3,'OTR_WD10',6,1)

c--17. 5 mm  double layer sensitive
        CALL UCTOH('WL17',WTDT(17),4,4)
        CALL CRVOLU('WL17',SHAP,CMP,3,'OTR_WD5',6,1)

c--18. 5 mm double layer nonsensitive
        CALL UCTOH('WL18',WTDT(18),4,4)
        CALL CRVOLU('WL18',SHAP,CMP,1,'OTR_WD5',3,1)

c--19. 10 mm single layer sensitive in magnetic field
        CALL UCTOH('WL19',WTDT(19),4,4)
        CALL CRVOLU('WL19',SHAP,CMP,4,'OTR_WS10',2,1)

c--20. 5 mm single layer sensitive in magnetic field
        CALL UCTOH('WL20',WTDT(20),4,4)
        CALL CRVOLU('WL20',SHAP,CMP,4,'OTR_WS5',2,1)

c--21. 5 mm single layer nonsensitive in magnetic field
        CALL UCTOH('WL21',WTDT(21),4,4)
        CALL CRVOLU('WL21',SHAP,CMP,2,'OTR_WS5',3,1)

c--22. 10 mm double layer sensitive in magnetic field
        CALL UCTOH('WL22',WTDT(22),4,4)
        CALL CRVOLU('WL22',SHAP,CMP,4,'OTR_WD10',3,1)

c--23. 5 mm  double layer sensitive in magnetic field
        CALL UCTOH('WL23',WTDT(23),4,4)
        CALL CRVOLU('WL23',SHAP,CMP,4,'OTR_WD5',2,1)

c--24. 5 mm double layer nonsensitive in magnetic field
        CALL UCTOH('WL24',WTDT(24),4,4)
        CALL CRVOLU('WL24',SHAP,CMP,2,'OTR_WD5',2,1)


c============================ only nonmagnet version of materials (PC)
c For volume WTBO xms=    34.06708
c For volume WTFR xms=    18.50000
c For volume WTPS xms=    28.55477
c For volume WTZS xms=    18.50000
c For volume WTST xms=    18.50000

c-- Board material
         CALL CRVOLU('WTBO','BOX ',CMP,1,'LUCITE',3,1)
c-- Frame material
         CALL CRVOLU('WTFR','BOX ',CMP,1,'G10',1,1)
c-- Pokalon stabi material
         CALL CRVOLU('WTPS','BOX ',CMP,1,'MYLAR',3,1)
c-- Z stabi material (G10/Rohacel/G10) !!! only G10 is used !!!
         CALL CRVOLU('WTZS','BOX ',CMP,1,'G10',6,1)
c-- G10 Strip material
         CALL CRVOLU('WTST','BOX ',CMP,1,'G10',7,1)

c============================ magnet/nonmagnet version of materials (MC)
c For volume WTIR xms=     1.76000
c For volume WTIM xms=     1.76000
c For volume WTPL xms=    34.06708
c For volume WTPM xms=    34.06708
c For volume WTAL xms=     8.90000
c For volume WTAM xms=     8.90000
c For volume WTRO xms=   535.98865
c For volume WTRM xms=   535.98865
c For volume WTGT xms=    18.50000
c For volume WTGM xms=    18.50000
c For volume WTCA xms=     1.43000
c For volume WTCM xms=     1.43000

c-- Iron material of cable frame - no magnet
         call CRVOLU('WTIR','BOX ',CMP,1,'IRON',6,1)
c-- Iron material of cable frame - magnet
         CALL CRVOLU('WTIM','BOX ',CMP,2,'IRON',6,1)
c-- Plexi glass material of cable frame and gas box - no magnet
         CALL CRVOLU('WTPL','BOX ',CMP,1,'LUCITE',4,1)
c-- Plexi glass material of cable frame and gas box - magnet
         CALL CRVOLU('WTPM','BOX ',CMP,2,'LUCITE',4,1)

c-- Alu material of gas box - no magnet
        CALL CRVOLU('WTAL','BOX ',CMP,1,'ALUMINIUM',3,0)
c-- Alu material of gas box - magnet
        CALL CRVOLU('WTAM','BOX ',CMP,2,'ALUMINIUM',3,0)

c-- Rohacel material of gas box  - no magnet
         CALL CRVOLU('WTRO','BOX ',CMP,1,'ROHACELL',5,1)
c-- Rohacel material of gas box  - magnet
         CALL CRVOLU('WTRM','BOX ',CMP,2,'ROHACELL',5,1)

c-- G10 strips (G10 material) - no magnet
         CALL CRVOLU('WTGT','BOX ',CMP,1,'G10',7,1)
c-- G10 strips (G10 material) - magnet
         CALL CRVOLU('WTGM','BOX ',CMP,2,'G10',7,1)

c-- Cable and preamp's (copper material) - no magnet !1'
         CALL CRVOLU('WTCA','BOX ',CMP,1,'COPPER',11,1)
c-- Cable and preamp's (copper material) - magnet !1'
         CALL CRVOLU('WTCM','BOX ',CMP,2,'COPPER',11,1)

c============================ additional materials for Dubna chambers (magnet)
c For volume WTDM xms=    18.50000
c For volume WTNM xms=   535.98865
c For volume WTBM xms=     1.43000

c-- G10 distance holders (G10 material) - magnet
         call CRVOLU('WTDM','TUBE',CMP,2,'G10',7,1)
c-- nomex honeycombs  - magnet
         call CRVOLU('WTNM','BOX ',CMP,2,'ROHACELL',4,1)
c-- brass distance pieces (copper material is used) - magnet
         call CRVOLU('WTBM','TUBE',CMP,2,'COPPER',6,1)


c============================ additional materials for 98 run chambers

c-- glass fiber
         call CRVOLU('WTGF','BOX ',CMP,1,'GLASSFIBER',5,-1) ! no magnet
         call CRVOLU('WTGL','BOX ',CMP,2,'GLASSFIBER',5,-1) ! magnet

c-- Paper honeycomb structure (for use in PC cover)
         call CRVOLU('WTPH','BOX ',CMP,1,'PC_COMB',5,-1) ! no magnet
         call CRVOLU('WTPI','BOX ',CMP,2,'PC_COMB',5,-1) ! magnet

c-- Aluminium honeycomb structure (for use in TC cover)
         call CRVOLU('WTAH','BOX ',CMP,1,'TC_COMB',5,-1)

c-- Carbon fibre (for use in MC cover)
         call CRVOLU('WTCF','BOX ',CMP,1,'CARBONFIBRE',5,-1) ! no magnet
         call CRVOLU('WTCI','BOX ',CMP,2,'CARBONFIBRE',5,-1) ! magnet

	return
        end
