
/***********************************************************************
* SZH3_ARTE
* written by Siegmund Nowak
*
* This routines allows changes in the automatically produced NEDE/NWAL
* banks for the rich 
*
*       called from GEOMAIN
*
* The transferred parameters are
* void szh3_arte_(int ncal,int nwal,char lvols[],int lcopy[],int nlev)  
***********************************************************************/

#include <stdio.h>
#include <string.h>
#include "arte/arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "gean/gclink.h"
#include "gean/zgeom.h"


void szh3_arte(int ncal,int ,char lvols[],int lcopy[],int nlev) {

    zgvol ZGVOL;
    
    if(ncal) {  

      int Gvolnum = ZGVOL.Check_Gvol(&lvols[4*nlev-4]);
      int jvos = *(gcbank_.lq + gclink_.jvolum -1 - Gvolnum);
      int *pji = gcbank_.iq + jvos + 2;
      float *pjx = (float *)pji;
      int nin = int(*pjx);
      for(int in = 1; in <= nin;in++) {
          int jin = *(gcbank_.lq + jvos -1 -in);
          pji = gcbank_.iq + jin +2;
          pjx = (float *)pji; 
          int iuser = int(*pjx);
          if(iuser == lcopy[nlev]){
	    float jx = float(ncal);
            memcpy(gcbank_.iq + jin +2, &jx,4);
            return;
          }
      }
      arteMsg << "szh3_arte: copy not found -contact S.Nowak ";
      arteMsg.error();        
    }
}          

/* szh3_arte_ */









