#include <iostream>
#include <fstream>
#include <string>
#include "grover/grover.hh"

// Part of the Grover package
// Please see the header file grover.hh
// for authors etc.
//
//
// Modifications:
// When?     Who?     What?
// YY-MM-DD  Name     Modification
// -----------------------------------------------------------------------------
//
//

GroverCuts groverCuts;

int GroverConfig(char* filename)
{
  //
  // Quick hack to allow tuning without recompilation
  // Note the groverCuts global object!
  // 
  // M.Sang 27/05/00
  //

  ifstream cutfile(filename);
  if (!cutfile.good()) {
    cout << "*** GroverConfig - ERROR - cannot open cut file" << endl;
    return -1;
  }
  else cout << "*** GroverConfig - reading cut values from "
	    << filename << endl;


  string name, comment;
  double value;

  while (cutfile.good()) {
    cutfile >> name >> value >> comment;
    if (name == "VertexingPackage") groverCuts.VertexingPackage
				      = static_cast<int>(value);
    else if (name == "GroverDraw") groverCuts.GroverDraw           
				      = static_cast<int>(value);
    else if (name == "FindJpsiPlusX") groverCuts.FindJpsiPlusX
					= static_cast<int>(value);
    else if (name == "FindUnbiased") groverCuts.FindUnbiased
				       = static_cast<int>(value);
    else if (name == "FindCharm") groverCuts.FindCharm
				    = static_cast<int>(value);
    else if (name == "VTmPsi") groverCuts.VTmPsi                
				 = value;
    else if (name == "VTmKs") groverCuts.VTmKs                 
				= value;
    else if (name == "VTmB") groverCuts.VTmB                  
			       = value;
    else if (name == "VTmpi") groverCuts.VTmpi                 
				= value;
    else if (name == "VTmmu") groverCuts.VTmmu                 
				= value;
    else if (name == "VTme") groverCuts.VTme                  
			       = value;
    else if (name == "VTch2wtr") groverCuts.VTch2wtr              
				   = static_cast<float>(value);
    else if (name == "VTch2wB") groverCuts.VTch2wB               
				  = static_cast<float>(value);
    else if (name == "VTxlmin") groverCuts.VTxlmin              
				  = static_cast<float>(value);
    else if (name == "VTxlwid") groverCuts.VTxlwid               
				  = static_cast<float>(value);
    else if (name == "VTntmin")  groverCuts.VTntmin               
				   = static_cast<int>(value);
    else if (name == "VTch2vtr") groverCuts.VTch2vtr              
				   = static_cast<float>(value);
    else if (name == "VTch2stt") groverCuts.VTch2stt              
				   = static_cast<float>(value);
    else if (name == "VTch2stv") groverCuts.VTch2stv              
				   = static_cast<float>(value);
    else if (name == "VTch2svw") groverCuts.VTch2svw             
				   = static_cast<float>(value);
    else if (name == "VTBvimpc") groverCuts.VTBvimpc              
				   = static_cast<float>(value);
    else if (name == "VTnmix") groverCuts.VTnmix                
				 = static_cast<int>(value);
    else if (name == "VTch2vv") groverCuts.VTch2vv               
				  = static_cast<float>(value);
    else if (name == "VTtweak") groverCuts.VTtweak               
				  = static_cast<int>(value);
    else if (name == "VTDraw") groverCuts.VTDraw                
				 = static_cast<int>(value);
    else if (name == "RPTrackChoice") groverCuts.RPTrackChoice           
					= static_cast<int>(value);
    else if (name == "RPTrackQualNH") groverCuts.RPTrackQualNH           
					= static_cast<int>(value);
    else if (name == "RPMinTrksInVtx") groverCuts.RPMinTrksInVtx        
					 = static_cast<int>(value);
    else if (name == "RPTrkWireSigmaMax") groverCuts.RPTrkWireSigmaMax     
					    = static_cast<float>(value);
    else if (name == "GPEActivate") groverCuts.GPEActivate               
				      = static_cast<int>(value);
    else if (name == "Paw") groverCuts.Paw                   
			      = static_cast<int>(value);
    else if (name == "Root") groverCuts.Root                  
			       = static_cast<int>(value);
    else if (name == "MassConstraint") groverCuts.MassConstraint
					 = static_cast<float>(value);
    else if (name == "CheatMass") groverCuts.CheatMass               
				    = static_cast<int>(value);
    else if (name == "CheatMomentum") groverCuts.CheatMomentum              
					= static_cast<int>(value);
    else if (name == "CheatSmearing") groverCuts.CheatSmearing
					= static_cast<int>(value);
    else if (name == "CheatSmearConst") groverCuts.CheatSmearConst
					  = static_cast<float>(value);
    else if (name == "CheatSmearVar") groverCuts.CheatSmearVar
					= static_cast<float>(value);
    else if (name == "Verbose") groverCuts.Verbose            
				  = static_cast<int>(value);
    else if (name == "GPEUpdateFreq") groverCuts.GPEUpdateFreq         
					= static_cast<int>(value);
    else if (name == "GPEMinHitsInTrack") groverCuts.GPEMinHitsInTrack     
					    = static_cast<int>(value);
    else if (name == "GPEMinTracksInVertex") groverCuts.GPEMinTracksInVertex  
					       = static_cast<int>(value);
    else if (name == "GPEMaxChi2") groverCuts.GPEMaxChi2  
				     = static_cast<float>(value);
    else if (name == "GPEMaxChi2PerTrack") groverCuts.GPEMaxChi2PerTrack  
					     = static_cast<float>(value);
    else if (name == "GPETransverseWindow") groverCuts.GPETransverseWindow   
					      = static_cast<float>(value);
    else if (name == "GPELongitudinalWindow") groverCuts.GPELongitudinalWindow 
						= static_cast<float>(value);
    else if (name == "GPEChiWindow") groverCuts.GPEChiWindow 
				       = static_cast<float>(value);
    else if (name == "RSJpsiSeedMaxChi2") groverCuts.RSJpsiSeedMaxChi2
					    = static_cast<float>(value);
    else if (name == "RSJpsiSeedMaxDist") groverCuts.RSJpsiSeedMaxDist
					    = static_cast<float>(value);
    /*
      else if (name == "RSVtxVtxMinChi2") groverCuts.RSVtxVtxMinChi2
      = static_cast<float>(value);
      else if (name == "RSTrkVtxMaxChi2") groverCuts.RSTrkVtxMaxChi2
      = static_cast<float>(value);
      else if (name == "RSTrkVtxMaxDist") groverCuts.RSTrkVtxMaxDist
      = static_cast<float>(value);
      else if (name == "RSTrkVtxDistRatio") groverCuts.RSTrkVtxDistRatio
      = static_cast<float>(value);
    */
    else if (name == "RSMinSeedIPS") groverCuts.RSMinSeedIPS
				       = static_cast<float>(value);
    else if (name == "RSMaxChi2Contrib") groverCuts.RSMaxChi2Contrib
					   = static_cast<float>(value);
    else if (name == "RSMaxTrkVtxChi2") groverCuts.RSMaxTrkVtxChi2
					  = static_cast<float>(value);
    else if (name == "RSMaxTrkTrkChi2") groverCuts.RSMaxTrkTrkChi2
					  = static_cast<float>(value);
    else if (name == "RSMax2TVtxChi2") groverCuts.RSMax2TVtxChi2
					 = static_cast<float>(value);
    else if (name == "RSMaxChi2PDOF") groverCuts.RSMaxChi2PDOF
					= static_cast<float>(value);
    else if (name == "GroverDraw3D") groverCuts.GroverDraw3D
				       = static_cast<int>(value);
    else if (name == "TDX3D") groverCuts.TDX3D
				= static_cast<int>(value);
    else if (name == "TDTargetRegion") groverCuts.TDTargetRegion
					 = static_cast<int>(value);
    else if (name == "TDAxes") groverCuts.TDAxes
				 = static_cast<int>(value);
    else if (name == "TDWires") groverCuts.TDWires
				  = static_cast<int>(value);
    else if (name == "TDPrimaries") groverCuts.TDPrimaries
				      = static_cast<int>(value);
    else if (name == "TDSecondaries") groverCuts.TDSecondaries
					= static_cast<int>(value);
    else if (name == "TDMCPrimaries") groverCuts.TDMCPrimaries
					= static_cast<int>(value);
    else if (name == "TDMCSecondaries") groverCuts.TDMCSecondaries
					  = static_cast<int>(value);
    else if (name == "TDPrimaryTracks") groverCuts.TDPrimaryTracks
					  = static_cast<int>(value);
    else if (name == "TDSecondaryTracks") groverCuts.TDSecondaryTracks
					    = static_cast<int>(value);
    else if (name == "TDUnusedTracks") groverCuts.TDUnusedTracks
					 = static_cast<int>(value);
    else if (name == "TDSpecialTracks") groverCuts.TDSpecialTracks
					  = static_cast<int>(value);
    else if (name == "TDWireColour") groverCuts.TDWireColour
				       = static_cast<int>(value);
    else if (name == "TDPrimaryColour") groverCuts.TDPrimaryColour
					  = static_cast<int>(value);
    else if (name == "TDSecondaryColour") groverCuts.TDSecondaryColour
					    = static_cast<int>(value);
    else if (name == "TDMCPrimaryColour") groverCuts.TDMCPrimaryColour
					    = static_cast<int>(value);
    else if (name == "TDMCSecondaryColour") groverCuts.TDMCSecondaryColour
					      = static_cast<int>(value);
    else if (name == "TDPrimaryTrackColour") groverCuts.TDPrimaryTrackColour
					       = static_cast<int>(value);
    else if (name == "TDSecondaryTrackColour") groverCuts.TDSecondaryTrackColour
						 = static_cast<int>(value);
    else if (name == "TDUnusedTrackColour") groverCuts.TDUnusedTrackColour
					      = static_cast<int>(value);
    else if (name == "TDSpecialTrackColour") groverCuts.TDSpecialTrackColour
					       = static_cast<int>(value);
    else if (name == "TDTrackSmoothness") groverCuts.TDTrackSmoothness
					    = static_cast<int>(value);
    else if (name == "TDPrimaryTrackLength") groverCuts.TDPrimaryTrackLength
					       = static_cast<float>(value);
    else if (name == "TDSecondaryTrackLength") groverCuts.TDSecondaryTrackLength
						 = static_cast<float>(value);
    else if (name == "TDUnusedTrackLength") groverCuts.TDUnusedTrackLength
					      = static_cast<float>(value);
    else if (name == "TDSpecialTrackLength") groverCuts.TDSpecialTrackLength
					       = static_cast<float>(value);
    else if (name == "TDXAxisLength") groverCuts.TDXAxisLength
					= static_cast<float>(value);
    else if (name == "TDYAxisLength") groverCuts.TDYAxisLength
					= static_cast<float>(value);
    else if (name == "TDZAxisLength") groverCuts.TDZAxisLength
					= static_cast<float>(value);
    else if (name == "TDAxisRadius") groverCuts.TDAxisRadius
				       = static_cast<float>(value);
  }

  groverCuts.Dump();

  return 0;
}
