#include "arte/arte.hh"
#include "grover/grover.hh"

// Part of the Grover package
// Please see the header file grover.hh
// for authors etc.
//
//
// Modifications:
// When?     Who?     What?
// YY-MM-DD  Name     Modification
// -----------------------------------------------------------------------------
//
//

int GroverFillFromGTAR(GroverWireList* gwl)
{
  int errorflag = 0;
  for (ArteTable<GTAR>::iterator igtar = ArteTable<GTAR>::begin();
       igtar != ArteTable<GTAR>::end(); ++igtar) {
    GroverWire temp(igtar);

    if (ArteTable<MCIN>::booked() && (temp.Number() == 2)){ 
      // special treatment of wrong wire in simu data
      
      float x   = temp.Y(); float y   = temp.Z(); float z   = temp.X();
              temp.SetX(x);         temp.SetY(y);         temp.SetZ(z);
    } 

    //if (ArteTable<MCIN>::booked() && (temp.Z() < -2.5)) continue; //!!!

    if (  !(fabs(temp.X())<0.001 && fabs(temp.Y())<0.001)
	  &&
	  ((temp.Horizontal() && fabs(temp.Y()) <= 1.0)||
	   (temp.Vertical()   && fabs(temp.X()) <= 1.0)  )
	  ){
      
      /*
	wire   VDS_reco      Target_DB     delta    Z-position
	------------------------------------------------------
	a1      1.882        -2.023        0.14      -14.15
	b1     -2.351        -2.009        0.34      -15.04
	i1     -5.358        -5.348        0.01      - 9.93
	o1     -0.242        -0.041        0.20      -11.84
	------------------------------------------------------
	a2      1.870        -2.835        0.97      -54.48
	b2     -2.370        -2.111        0.26      -56.67
	i2     -5.417        -4.707        0.71      -48.28
	o2     -0.437        -0.090        0.38      -50.55
	------------------------------------------------------
      */
      
      if (!ArteTable<MCIN>::booked()){
	switch (temp.Number()){
	case 1:  {temp.SetY( temp.Y() - 0.014 ); break;}
	case 2:  {temp.SetY( temp.Y() - 0.034 ); break;}
	case 3:  {temp.SetX( temp.X() + 0.001 ); break;}
	case 4:  {temp.SetX( temp.X() + 0.020 ); break;}
	case 5:  {temp.SetY( temp.Y() - 0.097 ); break;}
	case 6:  {temp.SetY( temp.Y() - 0.026 ); break;}
	case 7:  {temp.SetX( temp.X() + 0.071 ); break;}
	case 8:  {temp.SetX( temp.X() + 0.038 ); break;}
	}
      }	
      
      gwl->push_back(temp);
    }
  }
  if (gwl->empty()) errorflag = -1;
  return errorflag;
}
