*CMZ :          05/09/96  20.32.22  by  Fedor Ratnikov
*CMZ :  1.00/01 06/06/95  15.16.51  by  Dominik Ressing
*-- Author :    Fedor Ratnikov   02/03/95
************************************************************************
*
* L1USRTR
* written by Fedor Ratnikov, 02/03/95 11.55.03
*
* This routines action:
* User routine called in L1MCUFA when accept a new track candidate
*
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* MePo        in           Message pointer
*
*
************************************************************************
c
      SUBROUTINE L1USRTR(MePo)
c
      IMPLICIT NONE
#include "arte/Arte.fi"
#include "l1si/rcfdef.fi"
#include "l1si/ydef.fi"
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1mesdf.fi"
#include "l1si/l1user.fi"
#include "l1si/rchead.fi"
      INTEGER MePo,iPoPo,itrak,iver
      CHARACTER*4 cName
      LOGICAL HEXIST
#include "arte/Arte.ff"
#include "l1si/l1mesdf.ff"
#include "l1si/rcfunc.ff"
#include "l1si/ydef.ff"
c
      IF(HEXIST(L1TRATUPnr))   THEN
       L1TRATUibx = iRCEvent
       L1TRATUnint = nRCIntTot
       T1TRATUeinner = T1EVEinner(L1MEstor(MePo+L1MEprbx))
       L1TRATUpreType = L1MEstor(MePo+L1MEprid)
       T1TRATUp = T1MEstor(MePo+L1MEp)
       T1TRATUpx = T1MEstor(MePo+L1MEpx)
       T1TRATUpy = T1MEstor(MePo+L1MEpy)
       T1TRATUpz = T1MEstor(MePo+L1MEpz)
       T1TRATUepre = T1MEstor(MePo+L1MEpren)
       T1TRATUktrig = T1MEstor(MePo+L1MEprth)*T1DEFktrig
       T1TRATUcogx = MIN(T1MEstor(MePo+L1POlcogFactorX),4.)
       T1TRATUcogy = MIN(T1MEstor(MePo+L1POlcogFactorY),4.)
       T1TRATUebrem = T1MEstor(MePo+L1MEpren)*
     &      T1MEstor(MePo+L1MEBremRatio)
       iPoPo = MePo+L1MEpoint(0)+L1POreg
       T1TRATUx = T1MEstor(iPoPo+L1GEOINFx0)+
     &      0.5*T1MEstor(iPoPo+L1GEOINFsx)
       T1TRATUy = T1MEstor(iPoPo+L1GEOINFy0)+
     &      0.5*T1MEstor(iPoPo+L1GEOINFsy)
c      --- Monte-Carlo information
       itrak = L1MEstor(MePo+L1MEpretrk)
       IF(itrak.GT.0)   THEN
        CALL l1cpart(OMTRA_TOPP(itrak),L1TRATUidpre,cname) ! GEANT id
        T1TRATUppre = SQRT(FMTRA_PX(itrak)**2+
     &       FMTRA_PY(itrak)**2+FMTRA_PZ(itrak)**2)
        iver = IMTRA_ORIG(itrak)
c       look for real vertex
 110    CONTINUE
        IF(iver.LT.0)   THEN    ! parent track
         iver = IMTRA_ORIG(-iver)
         GOTO 110               ! try parent
        ENDIF
        IF(iver.GT.0)   THEN    ! vertex
         T1TRATUvz = FMVER_Z(iver)
         itrak = OMVER_BTRA(iver)
         CALL l1cpart(OMTRA_TOPP(itrak),L1TRATUidorig,cname) ! GEANT id
        ELSE
         L1TRATUidorig = 0
         T1TRATUvz = 0.
        ENDIF
       ELSE
        L1TRATUidpre = 0
       ENDIF
       itrak = L1MEstor(MePo+L1MEtrktrk)
       IF(itrak.GT.0)   THEN
        CALL l1cpart(OMTRA_TOPP(itrak),L1TRATUidtra,cname)
        T1TRATUptra = SQRT(FMTRA_PX(itrak)**2+
     &       FMTRA_PY(itrak)**2+FMTRA_PZ(itrak)**2)
       ELSE
        L1TRATUidtra = 0
       ENDIF
       L1TRATUnself = L1MEstor(MePo+L1MEghost)
       L1TRATUisp = L1MEstor(MePo+L1MEselfP)
       L1TRATUirp = L1MEstor(MePo+L1MErealP)
       CALL HFNT(L1TRATUPnr)
      ENDIF
c
      RETURN
c
      END


