*-- Author :    Rainer Mankel   08/11/93

      subroutine di1rseg(rs,islsta,islend,chopt)

*     **** display reconstructed segment
      implicit none
#include "pris/zgraf.fi"
#include "arte/Arte.fi"
      integer max_graf
      parameter (max_graf=200)
      integer rs, rh, ngraf, islsta, islend, isl, ipl, i_sort, n_sort,
     +     rh_sort(max_graf), 
     +     iirh, indx_rhit,
     +     rp, iirp, indx_rpnt, smk

      real wh(5), xxx(max_graf), yyy(max_graf), sna, zzz(max_graf),
     +     ltyp, lwid, txci, oin(max_graf)
      character*(*) chopt
      logical lplus, lzero, lplsup, spl
      character*2 opt_c, opt_l
      character*10 cnpart
#include "auto/RHIT.fi"
#include "auto/RSEG.fi"
#include "auto/RPNT.fi"
#include "auto/HITB.fi"
#include "auto/GESL.fi"
#include "auto/GEDE.fi"

#include "arte/Arte.ff"
#include "auto/RHIT.ff"
#include "auto/RSEG.ff"
#include "auto/RPNT.ff"
#include "auto/HITB.ff"
#include "auto/GESL.ff"
#include "auto/GEDE.ff"

*     **** stereo mode option
      lplus = index(chopt,'Y').gt.0
      lzero = index(chopt,'0').gt.0
      lplsup = lplus.or.lzero

*     **** ghosts option
      if (index(chopt,'U').gt.0) then
       if (prseg_mtra(rs).gt.0) go to 999
      endif

*     **** colour index
      call igset('PLCI',corszg)
      call igset('PMCI',corszg)
      call igset('LTYP',1.)
      call igset('LWID',6.)

      if (.not.lrcrhitzg) then

c Throw away some unphysical coordinates with cmp=4010001 rich + bit20 + vxd
         if (abs(frseg_xe(rs)-1000.).le.1.
     @ .and. abs(frseg_ye(rs)-1000.).le.1.
     @ .and. abs(frseg_txe(rs)-1000.).le.1.) goto 999

c Draw line connecting RSEG's first and last point: used after 'STYLE RTRHIT=N'
         n_sort = 1
         wh(1) = frseg_xf(rs)
         wh(2) = frseg_yf(rs)
         wh(3) = frseg_zf(rs)
         wh(4) = atan(frseg_txf(rs))
         wh(5) = atan(frseg_tyf(rs))
         call dipro5(wh,xxx(n_sort),yyy(n_sort))
         zzz(n_sort) = wh(3)
         
         n_sort = 2
         wh(1) = frseg_xe(rs)
         wh(2) = frseg_ye(rs)
         wh(3) = frseg_ze(rs)
         wh(4) = atan(frseg_txe(rs))
         wh(5) = atan(frseg_tye(rs))
         call dipro5(wh,xxx(n_sort),yyy(n_sort))
         zzz(n_sort) = wh(3)

         goto 11
      endif

*     **** loop over reconstructed hits
      n_sort = 0
      do 10 iirh=1,999
         if (iirh.eq.1) then
            indx_rhit = prseg_rhit(rs)
         else
            indx_rhit = xrseg_rhit(indx_rhit)
         endif
         if (indx_rhit.le.0) go to 11
         rh = mrseg_rhit(indx_rhit)
         if (index(chopt,'L').gt.0)
     +        print *,' di1rseg: display RHIT=', rh
         ipl = ihitb_gede(orhit_hitb(rh))
         isl = ogede_gesl(ipl)
         if (isl.lt.islsta.or.isl.gt.islend) go to 10
         if (modezg.eq.1) then
            if (isl.gt.scmxzg) go to 10
            if (.not.lscopzg(isl)) go to 10
         endif

*        **** check plane
         if (lplsup) then
            sna = abs( fgede_sin(ipl))
            if (sna.gt.1.e-10.and.lzero) go to 10
            if (sna.le.1.e-10.and.lplus) go to 10
         endif

         if (n_sort.lt.max_graf) then
            n_sort = n_sort + 1
            wh(1) = frhit_x(rh)
            wh(2) = frhit_y(rh)
            wh(3) = fhitb_z(orhit_hitb(rh))
            wh(4) = atan(frhit_tx(rh))
            wh(5) = atan(frhit_ty(rh))
            call dipro5(wh,xxx(n_sort),yyy(n_sort))
            zzz(n_sort) = wh(3)
         else
            print *,' () di1rseg: overflowing n_sort=', n_sort
            stop 'di1rseg'
         endif
 10   continue
 11   continue


c Add point at Z=zcont
      if ((frseg_zf(rs)-450.)*(zcont-450.) .gt. 0. ! for segments on the same side of magnet
     @ .and. zcont .lt. frseg_zf(rs)               ! and ZCONT is down from RSEG begin
     @ .and. zcont .ge. -90.) then                 ! and for reasonable ZCONT values
         n_sort = n_sort + 1
         wh(1) = frseg_xf(rs) + (zcont-frseg_zf(rs))*frseg_txf(rs)
         wh(2) = frseg_yf(rs) + (zcont-frseg_zf(rs))*frseg_tyf(rs)
         wh(3) = zcont
         wh(4) = atan(frseg_txf(rs))
         wh(5) = atan(frseg_tyf(rs))
         call dipro5(wh,xxx(n_sort),yyy(n_sort))
         zzz(n_sort) = wh(3)
      end if

#ifdef RPNT
*     **** loop over reconstructed points
      do 20 iirp=1,999
         if (iirp.eq.1) then
            indx_rpnt = prseg_rpnt(rs)
         else
            indx_rpnt = xrseg_rpnt(indx_rpnt)
         endif
         if (indx_rpnt.le.0) go to 21
         rp = mrseg_rpnt(indx_rpnt)
         if (index(chopt,'L').gt.0)
     +        print *,' di1rseg: display RPNT=', rp
#ifdef LATER
         if (isl.lt.islsta.or.isl.gt.islend) go to 20
         if (modezg.eq.1) then
            if (isl.gt.scmxzg) go to 20
            if (.not.lscopzg(isl)) go to 20
         endif

*        **** check plane
         if (lplsup) then
            sna = abs( fgede_sin(ipl))
            if (sna.gt.1.e-10.and.lzero) go to 20
            if (sna.le.1.e-10.and.lplus) go to 20
         endif
#endif

         if (n_sort.lt.max_graf) then
            n_sort = n_sort + 1
            zzz(n_sort) = frpnt_zf(rp)
            wh(1) = frpnt_xf(rp) ! 3D point from RPNT
            wh(2) = frpnt_yf(rp)
            wh(3) = frpnt_zf(rp)
            wh(4) = atan(frpnt_txf(rp))
            wh(5) = atan(frpnt_tyf(rp))
            call dipro5(wh,xxx(n_sort),yyy(n_sort)) ! projection
         else
            print *,' () di1rseg: overflowing n_sort=', n_sort
            stop 'di1rseg'
         endif
 20   continue
 21   continue
#endif


*     **** draw the graph
      if (lcrosszg) then
         call ismk(28)          ! set marker type
         call ismksc(1.5)       ! marker scale factor
         opt_l = 'LP'
         opt_c = 'CP'
      else
         opt_l = 'L'
         opt_c = 'C'
      endif


      lwid = widrczg
      spl = lsplinezg.and.abs(frseg_pf(rs)).gt.1
      txci = corszg

      cnpart = ' '
*      if (ltypezg) then         ! particle label option
*         if (gcode.ge.1.and.gcode.le.maxgcode) then
*            cnpart = cn(gcode)
*         else
*            cnpart = ' '
*         endif
*      endif

      smk = 0
      if (lcrosszg) smk = 28

      call ditraj(n_sort,xxx,yyy,zzz,zzz,lwid,ltyp,spl,.true.,
     +     .true.,smk,txci,cnpart)

*     **** draw RPNT markers
      if (lcrosszg) then
         n_sort = 0
         do 30 iirp=1,999
            if (iirp.eq.1) then
               indx_rpnt = prseg_rpnt(rs)
            else
               indx_rpnt = xrseg_rpnt(indx_rpnt)
            endif
            if (indx_rpnt.le.0) go to 31
            rp = mrseg_rpnt(indx_rpnt)

            if (n_sort.lt.max_graf) then
               n_sort = n_sort + 1
               zzz(n_sort) = frpnt_zf(rp)
               wh(1) = frpnt_xf(rp) ! 3D point from RPNT
               wh(2) = frpnt_yf(rp)
               wh(3) = frpnt_zf(rp)
               wh(4) = atan(frpnt_txf(rp))
               wh(5) = atan(frpnt_tyf(rp))
               call dipro5(wh,xxx(n_sort),yyy(n_sort)) ! projection
               call ismk(24)    ! set marker type
               call ismksc(3.0) ! marker scale factor
               call ipm(1,xxx(n_sort),yyy(n_sort))
            else
               print *,' () di1rseg: overflowing n_sort=', n_sort
               stop 'di1rseg'
            endif
 30      continue
 31      continue
      endif

 999  end
