*CMZ :          16/08/96  21.31.19  by   Ivan Belyaev
*-- Author :     Ivan Belyaev   16/08/96

      SUBROUTINE DIRV(iv,CHOPT)

************************************************************************
*
* Description: DISPLAY Reconstructed Vertex
*
* Called from:
*
* External references: RSINV,EISRS1
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi" 
#include "auto/EV.fi"
#include "pris/zgraf.fi"

      INTEGER  iv,iv1,iv2
      CHARACTER*(*)  CHOPT

      INTEGER  iVERT
      REAL     X(3),XXX(2),YYY(2)
C*    Matrix
      REAL       E(3,3),EIG(3),EIGV(3,3)
      REAL       WORK(3,3)
C*    Drawing
      INTEGER    iPoint, nPoint,iFAIL
      REAL       TWOPISTEP
      PARAMETER( nPoint    = 36 )
      PARAMETER( TWOPISTEP = TWOPI/nPoint )
      REAL       C( 3 )
      REAL       CX1( 0 : nPoint ) , CY1( 0 : nPoint )
      REAL       CX2( 0 : nPoint ) , CY2( 0 : nPoint )
      REAL       CX3( 0 : nPoint ) , CY3( 0 : nPoint )
      REAL       SINP,COSP,SINT,COST

      INTEGER    LENOCC 
      EXTERNAL   LENOCC

#include "arte/Arte.ff" 
#include "auto/EV.ff"


      IF(     JRVER.EQ.0)THEN
       C78='DIRV()==>No Reconstructed Vertex to be displayed!'
       CALL MEMESC(46932,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       RETURN
      ELSEIF(NRVER().EQ.0)THEN
       C78='DIRV()==>No Reconstructed Vertex to be displayed!'
       CALL MEMESC(46932,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       RETURN
      ENDIF

      IF(      IV.LE.0)THEN
       IV1 = 1
       IV2 = NRVER()
      ELSEIF(  IV.LE.NRVER())THEN
       IV1 = IV
       IV2 = IV
      ELSE
       IV1 = 1
       IV2 = NRVER()
      ENDIF


      CALL ISMKSC( 1.0 )
      CALL IGSET ( 'LWID' , 1.0 )
      CALL IGSET ( 'LTYP' , 1.0 )
      CALL IGSET ( 'PLCI' , 1.0 )

      DO iVERT = iV1 , iV2
C*     Draw a vertex iVERT
       X( 1 ) = FRVER_XV( iVERT  )
       X( 2 ) = FRVER_YV( iVERT  )
       X( 3 ) = FRVER_ZV( iVERT  )
       CALL DIPRO( X , XXX(1) , YYY(1) )
C*     Fill Error matrix
       E( 1 , 1 ) = FRVER_CV( 1 , iVERT )
       E( 1 , 2 ) = FRVER_CV( 2 , iVERT )
       E( 2 , 1 ) = E( 1 , 2 )
       E( 2 , 2 ) = FRVER_CV( 3 , iVERT )
       E( 1 , 3 ) = FRVER_CV( 4 , iVERT )
       E( 3 , 1 ) = E( 1 , 3 )
       E( 2 , 3 ) = FRVER_CV( 5 , iVERT )
       E( 3 , 2 ) = E( 2 , 3 )
       E( 3 , 3 ) = FRVER_CV( 6 , iVERT )
C*     Find the EigenValues and EigenVectors
       CALL EISRS1(3,3,E,EIG,EIGV,iFAIL,WORK)
       IF( iFAIL .NE. 0 )THEN
        C78='DIRV==> Impossible to invert the ERROR matrix!'
        CALL MEMESC(83471982,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
        GO TO 100
       ENDIF
       IF(       EIG( 1 ) .LE. 0.0  .OR. 
     &           EIG( 2 ) .LE. 0.0  .OR. 
     &           EIG( 3 ) .LE. 0.0       )THEN
        C78='DIRV==> Negative eigenvalues for Error Matrix!' 
        CALL MEMESC(4578798,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
        GO TO 100      
       ENDIF 
       EIG( 1 ) = SQRT( EIG( 1 ) )
       EIG( 2 ) = SQRT( EIG( 2 ) )
       EIG( 3 ) = SQRT( EIG( 3 ) )
       DO iPoint = 0 , nPoint
C*      Theta = 0
        SINP  = EIG(1)*SIN( FLOAT(iPoint) * TWOPISTEP )
        COSP  = EIG(2)*COS( FLOAT(iPoint) * TWOPISTEP )
        C(1)  = EIGV(1,1)*SINP+EIGV(2,1)*COSP+FRVER_XV(iVERT)
        C(2)  = EIGV(1,2)*SINP+EIGV(2,2)*COSP+FRVER_YV(iVERT)
        C(3)  = EIGV(1,3)*SINP+EIGV(2,3)*COSP+FRVER_ZV(iVERT)
        CALL DIPRO( C , CX1(iPoint) , CY1(iPoint) )
C*      Phi   = 0
        COST  = EIG(2)*COS( FLOAT(iPoint) * TWOPISTEP )
        SINT  = EIG(3)*SIN( FLOAT(iPoint) * TWOPISTEP )
        C(1)  = EIGV(2,1)*COST+EIGV(3,1)*SINT+FRVER_XV(iVERT)
        C(2)  = EIGV(2,2)*COST+EIGV(3,2)*SINT+FRVER_YV(iVERT)
        C(3)  = EIGV(2,3)*COST+EIGV(3,3)*SINT+FRVER_ZV(iVERT)
        CALL DIPRO( C , CX2(iPoint) , CY2(iPoint) )
C*      Phi   = pi/2
        COST  = EIG(1)*COS( FLOAT(iPoint) * TWOPISTEP )
        SINT  = EIG(3)*SIN( FLOAT(iPoint) * TWOPISTEP )
        C(1)  = EIGV(1,1)*COST+EIGV(3,1)*SINT+FRVER_XV(iVERT)
        C(2)  = EIGV(1,2)*COST+EIGV(3,2)*SINT+FRVER_YV(iVERT)
        C(3)  = EIGV(1,3)*COST+EIGV(3,3)*SINT+FRVER_ZV(iVERT)
        CALL DIPRO( C , CX3(iPoint) , CY3(iPoint) )
       ENDDO
       CALL IGRAPH( nPoint+1  , CX1(0) , CY1(0) , 'C' )
       CALL IGRAPH( nPoint+1  , CX2(0) , CY2(0) , 'C' )
       CALL IGRAPH( nPoint+1  , CX3(0) , CY3(0) , 'C' )
C*     End of Draw vertex iVERT
 100   CONTINUE
      ENDDO

      END

************************************************************************
* End of DIRV
************************************************************************







