*-- Author :    Rainer Mankel   14/05/98

#include "rang/FLAGRotFix.hh"

      subroutine ditubs(xx,yy,zz,mad,rot,cob,cov)

*     **** draw tube segment, ignore thickness
      integer np,ii
      real rad57
      parameter (np=21,rad57=57.2957795)
      real xx(2),yy(2),zz(2),mad(3),rot(9),cob,cov
      real wc(3,np), xxx(np), yyy(np),r,phi1,phi2

**      print *,' ditubs: xx,yy,zz,mad,rot,cob,cov=',
**     +     xx,yy,zz,mad,rot,cob,cov

      dphi = (mad(2) - mad(1)) / 9 / rad57
      r = 0.5 * (xx(1)+xx(2))
      phi1 = mad(1) / rad57
      phi2 = mad(2) / rad57

#ifndef ROTFIX 
      do ii=1,10
         wc(1,ii) = yy(1) + r * cos(phi1+(ii-1)*dphi)
         wc(2,ii) = yy(2) + r * sin(phi1+(ii-1)*dphi)
         wc(3,ii) = zz(1)
      enddo

      do ii=11,20
         wc(1,ii) = yy(1) + r * cos(phi1+(20-ii)*dphi)
         wc(2,ii) = yy(2) + r * sin(phi1+(20-ii)*dphi)
         wc(3,ii) = zz(2)
      enddo

      wc(1,21) = wc(1,1)
      wc(2,21) = wc(2,1)
      wc(3,21) = wc(3,1)

      do ii=1,np
         call dirot(wc(1,ii),rot)
         call dipro(wc(1,ii),xxx(ii),yyy(ii))
      enddo
#else
*     **** fix for older geom implementation
       do ii=1,10
         wc(1,ii) = yy(1) + r * cos(phi1+(ii-1)*dphi)
         wc(2,ii) = yy(2) + r * sin(phi1+(ii-1)*dphi)
         wc(3,ii) = zz(1)
      enddo

      do ii=11,20
         wc(1,ii) = yy(1) + r * cos(phi1+(20-ii)*dphi)
         wc(2,ii) = yy(2) + r * sin(phi1+(20-ii)*dphi)
         wc(3,ii) = zz(2)
      enddo

      wc(1,21) = wc(1,1)
      wc(2,21) = wc(2,1)
      wc(3,21) = wc(3,1)

      do ii=1,np
         wc(3,ii) = wc(3,ii) - 1080. ! shift to gean center of rotation
         call dirot(wc(1,ii),rot)
         wc(3,ii) = wc(3,ii) + 1080. ! shift back
         call dipro(wc(1,ii),xxx(ii),yyy(ii))
      enddo
     
#endif     



**      print *,' cov,cob=',cov,cob
**      print *,' the x coordinates are: ',xxx
**      print *,' the y coordinates are: ',yyy

      call igset('PLCI',cov)
      call igset('FACI',cov)
      call igset('FAIS',1.)
      call igset('BORD',0.)
      call ifa(np,xxx,yyy)      ! draw volume

      call igset('PLCI',cob) ! draw border
      call igset('FAIS',0.)
      call igset('LWID',7.)
      call ipl(np,xxx,yyy)

      call igset('LWID',1.)     ! reset
      call isfaci(0)
      call isfais(0)

      end
