// 
//  Author:  Rainer Mankel                     Created:  09-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerNavItem
// basic ranger navigation object

#ifndef RANGER_NAVITEM_HH
#define RANGER_NAVITEM_HH

#include <vector.h>

class rangerDomWin;
class rangerDomain;
class rangerSNMList;

class rangerNavItem {

public: 
  rangerNavItem();
  rangerNavItem(rangerDomWin* dw);
  ~rangerNavItem();

  void setNavTable(const vector<rangerDomain*>::iterator dbeg,
		   const vector<rangerDomain*>::iterator dend,
		   const rangerSNMList& snl,
		   const int minScope,
		   const int maxScope,
		   const int maxInt=99);
  rangerDomWin* win() const { return wi; };
  vector<rangerNavItem*>& getTargets(const int direction) {
    return ((direction == 1)? (forwardTargets)
	    : (backwardTargets)); };
  void dump(const int level=1);

private:
  vector<rangerNavItem*> forwardTargets;
  vector<rangerNavItem*> backwardTargets;
  rangerDomWin* wi;
};

#endif

