// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerVolTube
// volume class for tube shape

#ifndef rangerVolTube_HH
#define rangerVolTube_HH

#include "rang/Volume.hh"
#include "rang/GeWa.hh"

class rangerVolTube : public rangerVolume {

public:
  rangerVolTube(); // default constructor
  rangerVolTube( rangerGeWa* gewa ); // constructor from gewa
  ~rangerVolTube(); // destructor

  double sLength(double zz,
	     double x,
	     double y,
	     double tx,
	     double ty); // return traversed length
                         // in units of (zmax-zmin)
  const float zMean();   // mean z for sort
};

#endif
