*-- Author :    Rainer Mankel   17/05/95

      subroutine tfxrang(ipl,x_min,x_max)

*     **** return valid range of x coordinate for each plane
      implicit none

#include "rang/zbric.fi"
#include "rang/zfout.fi"
      integer cmp, shp, ipl, jpl, ii
      real x_min, x_max, x(4), y(4), xx(4), yy(4)
      integer maxxpl
      parameter (maxxpl=5000)
      real xmin_pl(maxxpl), xmax_pl(maxxpl)
      logical init, filled_pl(maxxpl)

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"

      save init, xmin_pl, xmax_pl, filled_pl
      data init /.false./

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"

      if (.not.init) then
       if (llog_zfout) print *,' tfxrang: init, iq(jgede+2),',
     +        '  maxxpl=', iq(jgede+2),maxxpl
       do 10 jpl=1,min0(iq(jgede+2),maxxpl)  ! loop over all planes
        cmp = igede_cmp(jpl)
        if (cmp.ge.1.and.cmp.le.3) then  ! select si, straw, msgc
*        **** calculate valid x range
         shp = igede_shp(jpl)
         if (shp.eq.1.or.shp.eq.2.or.shp.eq.34.or.shp.eq.42) then       ! box
          x(1) = fgede_sxmn(jpl)
          y(1) = fgede_symn(jpl)
          x(2) = fgede_sxmx(jpl)
          y(2) = fgede_symn(jpl)
          x(3) = fgede_sxmx(jpl)
          y(3) = fgede_symx(jpl)
          x(4) = fgede_sxmn(jpl)
          y(4) = fgede_symx(jpl)
         elseif (shp.eq.10) then  ! epiped
          x(1) = fgede_sxmn(jpl)
     +         + fgede_symn(jpl) * fgede_sin(jpl) / fgede_cos(jpl)
          y(1) = fgede_symn(jpl)
          x(2) = fgede_sxmx(jpl)
     +         + fgede_symn(jpl) * fgede_sin(jpl) / fgede_cos(jpl)
          y(2) = fgede_symn(jpl)
          x(3) = fgede_sxmx(jpl)
     +         + fgede_symx(jpl) * fgede_sin(jpl) / fgede_cos(jpl)
          y(3) = fgede_symx(jpl)
          x(4) = fgede_sxmn(jpl)
     +         + fgede_symx(jpl) * fgede_sin(jpl) / fgede_cos(jpl)
          y(4) = fgede_symx(jpl)
         else                     ! unknown
          print *,' () tfxrang: invalid shape, jpl, shp=', jpl, shp
          xmin_pl(jpl) =  0.
          xmax_pl(jpl) = -1.
          filled_pl(jpl) = .true.
          go to 10
         endif

*        **** rotation
         do ii=1,4
          xx(ii) = x(ii) * fgede_rot(1,jpl) + y(ii) * fgede_rot(2,jpl)
          yy(ii) =-x(ii) * fgede_rot(2,jpl) + y(ii) * fgede_rot(1,jpl)
         enddo

         xmin_pl(jpl) = min(xx(1),xx(2),xx(3),xx(4))
         xmax_pl(jpl) = max(xx(1),xx(2),xx(3),xx(4))
         filled_pl(jpl) = .true.
        else ! other cmp
         filled_pl(jpl) = .false.
        endif
 10    continue                     ! loop over planes
       init = .true.
      endif ! init done

*     **** get values
      if (ipl.gt.0.or.ipl.le.maxxpl) then
       if (filled_pl(ipl)) then
        x_min = xmin_pl(ipl)
        x_max = xmax_pl(ipl)
       else
        print *,' () tfxrang: not filled for ipl=', ipl
        x_min = 0.
        x_max = 0.
       endif
      else
       print *,' () tfxrang: outside maxxpl, ipl=', ipl
       x_min = 0.
       x_max = 0.
      endif

 999  end

