
// *****************************************************************************
//
// source:    rcClassJPSIEE.C
//
// type:      source code
//
// created:   20 Jun 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    rcClassJPSIEE
//
// called by: rcClassify
//
// purpose:   check for J/Psi -> e+e- event
//
// hints:     do NOT set flagdst here!
//
// changes:
// 20 Jun 2000 (AG) creation
// 20 Jul 2000 (AG) add ARTE_mark()
//
// *****************************************************************************

// standard includes

// ARTE includes
#include "arte/arte.hh"
#include "farm/farm.hh"

// externals
extern int rcSelectTracksStatus;

//
// function code
//
int
rcClassJPSIEE()
{
  ARTE_mark( "rcClassJPSIEE 0", 0 );
  
  // check track selection
  int rc = 0;  
  if( rcSelectTracksStatus ){
    
    // loop over tracks  
    for( ArteTable<RTRA>::iterator rtra = ArteTable<RTRA>::begin();
	 rtra != ArteTable<RTRA>::end();
	 ++rtra ){
      if( (*rtra)->fit == 2 ) rc = 1; // event found
    }
  }
  
  ARTE_mark( "rcClassJPSIEE 1", 0 );
  return rc;
}
