
// *****************************************************************************
//
// source:    rcSelectJPSIMM.C
//
// type:      source code
//
// created:    6 Oct 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    rcSelectJPSIMM
//
// called by: rcClassJPSIMM
//
// purpose:   select events with J/Psi -> mu+ mu-
//
// hints:     rc = 0x0: nothing selected
//            rc = 0x1: decay found
//
// changes:
//  6 Oct 2000 (AG) creation
//
// *****************************************************************************

// standard includes
#include <iostream.h>

// ARTE include
#include "arte/arte.hh"
#include "farm/farm.hh"

// externals
extern int FADEB;

// prototypes

//
// function code
//
int
rcSelectJPSIMM()
{
  ARTE_mark( "rcSelectJPSIMM 0", 0 );

  // inits
  int rc = 0;
  
  // put your analysis code here

  // print
  if( FADEB ) cout << " SELECT: JPSIMM=0x" << hex << rc << dec << endl; 

  // return
  ARTE_mark( "rcSelectJPSIMM 1", 0 );
  return rc;
}
