*-- Author :    Vitaly Eiges   05/07/2000

c     Returns negative: event is not selected
c                    0: event is selected
c             positive: tight selection, mass for histogramming
c
c     changes:
c     07 Jul 2000 (AG) called it RCMUONJPSI
c

      REAL FUNCTION RCMUONJPSI()

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/RSEG.fi"

          integer  i, j, l

          real x,y,z,tx,ty, rc

          integer n_muon, n_rich, n_vds

          real muon_x(10), vds_x(60)
          real muon_y(10), vds_y(60)
          real muon_z(10), vds_z(60)
          real muon_tx(10), vds_tx(60), rich_tx(60)
          real muon_ty(10), vds_ty(60), rich_ty(60)

          real z_mu1
          real thc_0, dthc

          real ty_cut         
          real tx_cut_rich 

          integer tra_m(50), tra_r(50), tra_v(50)
          real tra_p(50), tra_tx(50), tra_ty(50)

          real px1, px2, py1, py2, pz1, pz2, e1, e2
          real pt1, pt2, um, umm, ummmax
          real pxs, pys, pzs, es

          integer n_tra
          real tr(5), p_tra, x_mu1

#include "arte/Arte.ff"
#include "auto/RSEG.ff"

          data z_mu1 / 1620. /
          data thc_0 / 0.052 /
          data dthc / 0.003 /
          data ty_cut / 0.006 /
          data tx_cut_rich / 0.030 /

          n_muon = 0
          n_vds = 0
          n_rich = 0

          do i = 1, nrseg()

             x = frseg_xf(i)
             y = frseg_yf(i)
             z = frseg_zf(i)
             tx = frseg_txf(i)
             ty = frseg_tyf(i)

             if (irseg_cmp(i).eq.8.and.n_muon.lt.10) then
                n_muon = n_muon + 1
                muon_x(n_muon) = x+(z_mu1-z)*tx
                muon_y(n_muon) = y+(z_mu1-z)*ty
                muon_z(n_muon) = z_mu1
                muon_tx(n_muon) = tx
                muon_ty(n_muon) = muon_y(n_muon)/z_mu1
             endif

             if (irseg_cmp(i).eq.65537.and.n_vds.lt.60) then ! vds
                n_vds = n_vds + 1
                vds_x(n_vds) = x
                vds_y(n_vds) = y
                vds_z(n_vds) = z
                vds_tx(n_vds) = tx
                vds_ty(n_vds) = ty
             endif       
             
             if (irseg_cmp(i).eq.67108864.and.
     &            frseg_time(i).lt.(thc_0+dthc).and.
     &            frseg_time(i).gt.(thc_0-dthc).and.
     &            n_rich.lt.60) then        ! rich
                n_rich = n_rich + 1
                rich_tx(n_rich) = tx
                rich_ty(n_rich) = ty
             endif

          enddo

          n_tra = 0

          do i = 1, n_muon
             do j = 1, n_rich
                if (abs(muon_ty(i)-rich_ty(j)).lt.ty_cut.and.
     &               abs(muon_tx(i)-rich_tx(j)).lt.tx_cut_rich) then
                   do l = 1, n_vds
                      if (abs(muon_ty(i)-vds_ty(l)).lt.ty_cut) then
                         n_tra = n_tra + 1
                         tr(1) = vds_x(l)
                         tr(2) = vds_y(l)
                         tr(3) = vds_z(l)
                         tr(4) = vds_tx(l)
                         tr(5) = vds_ty(l)
                         call mdbend(tr, rich_tx(j), p_tra, x_mu1)
                         tra_m(n_tra) = i
                         tra_r(n_tra) = j
                         tra_v(n_tra) = l
                         tra_p(n_tra) = p_tra
                         tra_tx(n_tra) = vds_tx(l)
                         tra_ty(n_tra) = vds_ty(l)
                         if (abs(muon_x(i)-x_mu1).gt.2.5) 
     &                        n_tra = n_tra - 1
                      endif
                   enddo
                endif
             enddo
          enddo
          
          ummmax = 0.
          um = 0.105

          rc = -999.            ! not selected by default
          
          do i = 1, n_tra
             do j = i+1, n_tra
                if (tra_m(i).ne.tra_m(j).and.tra_r(i).ne.tra_r(j).and.
     &               tra_v(i).ne.tra_v(j)) then
                   if((tra_p(i)*tra_p(j)).lt.0) then
                      rc = 0.   ! event selected
                      px1 = abs(tra_p(i))*tra_tx(i)/
     &                     sqrt(1.+tra_tx(i)**2+tra_ty(i)**2)
                      py1 = abs(tra_p(i))*tra_ty(i)/
     &                     sqrt(1.+tra_tx(i)**2+tra_ty(i)**2)
                      pz1 = abs(tra_p(i))/
     &                     sqrt(1.+tra_tx(i)**2+tra_ty(i)**2)
                      px2 = abs(tra_p(j))*tra_tx(j)/
     &                     sqrt(1.+tra_tx(j)**2+tra_ty(j)**2)
                      py2 = abs(tra_p(j))*tra_ty(j)/
     &                     sqrt(1.+tra_tx(j)**2+tra_ty(j)**2)
                      pz2 = abs(tra_p(j))/
     &                     sqrt(1.+tra_tx(j)**2+tra_ty(j)**2)
                      pt1 = sqrt(px1**2+py1**2)
                      pt2 = sqrt(px2**2+py2**2)
                      e1 = sqrt(tra_p(i)**2+um**2)
                      e2 = sqrt(tra_p(j)**2+um**2)
                      pxs = px1+px2
                      pys = py1+py2
                      pzs = pz1+pz2
                      es = e1+e2
                      umm = sqrt(es**2-pxs**2-pys**2-pzs**2)
                      if (umm.gt.ummmax.and.pt1.gt.1.2.and.pt2.gt.1.2) 
     &                     ummmax = umm
                   endif
                endif
             enddo
          enddo
          
          if (ummmax.ne.0) rc = ummmax
          
          rcmuonjpsi = rc         ! value returned
          
          return
 900      END
