#include "rich/Losses.h"


int richLossCounter[24]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
int norma=0;

double lossfrac(int loss,int *norm,int norm0) {
  double ret=double(loss)/double(norm0);
  *norm-=loss;
  return ret;
}


void printloss(FILE* fp=stdout) {
  int norm=norma;
  int normold=norm;
  int norm0=norm;
  fprintf(fp,"----------------------------------------------------------------------\n");
  fprintf(fp,"Total ................ %6d\n",norm);
  fprintf(fp,"Vessel .....\n");
  fprintf(fp,"  p-beam shroud ................: (left: %6d) %e\n",norm,lossfrac(richLossCounter[VES_LOSS_PBEAMSHROUD],&norm,normold));
  fprintf(fp,"  e-beam shroud ................: (left: %6d) %e\n",norm,lossfrac(richLossCounter[VES_LOSS_EBEAMSHROUD],&norm,normold));
  fprintf(fp,"  plane mirror backside ........: (left: %6d) %e\n",norm,lossfrac(richLossCounter[VES_LOSS_PMI_BACKSIDE],&norm,normold));
  fprintf(fp,"  total ........................: (left: %6d) %e\n\n",norm,1.0-double(norm)/double(normold));
  normold=norm;
  fprintf(fp,"----------------------------------------------------------------------\n");
  fprintf(fp,"Spherical Mirror .....\n");
  fprintf(fp,"  photon not inside mirror .....: (left: %6d) %e\n",norm,lossfrac(richLossCounter[SMI_LOSS_OUTOFSPHERE],&norm,normold));
  fprintf(fp,"  reflexion losses .............: (left: %6d) %e\n",norm,lossfrac(richLossCounter[SMI_LOSS_REFLECTIVITY],&norm,normold));
  fprintf(fp,"  mirror gaps ..................: (left: %6d) %e\n",norm,lossfrac(richLossCounter[SMI_LOSS_MIRRORGAPS],&norm,normold));
  fprintf(fp,"  outside of mirror bounds .....: (left: %6d) %e\n",norm,lossfrac(richLossCounter[SMI_LOSS_OUTOFMIRROR],&norm,normold));
  fprintf(fp,"  p-beam cut out ...............: (left: %6d) %e\n",norm,lossfrac(richLossCounter[SMI_LOSS_PBEAMCUTOUT],&norm,normold));
  fprintf(fp,"  e-beam cut out ...............: (left: %6d) %e\n",norm,lossfrac(richLossCounter[SMI_LOSS_EBEAMCUTOUT],&norm,normold));
  fprintf(fp,"  total ........................: (left: %6d) %e\n\n",norm,1.0-double(norm)/double(normold)); 
  normold=norm;
  fprintf(fp,"----------------------------------------------------------------------\n");
  fprintf(fp,"Plane Mirror .....\n");
  fprintf(fp,"  reflexion losses .............: (left: %6d) %e\n",norm,lossfrac(richLossCounter[PMI_LOSS_REFLECTIVITY],&norm,normold));
  fprintf(fp,"  mirror gaps ..................: (left: %6d) %e\n",norm,lossfrac(richLossCounter[PMI_LOSS_MIRRORGAPS],&norm,normold));
  fprintf(fp,"  outside of mirror bounds .....: (left: %6d) %e\n",norm,lossfrac(richLossCounter[PMI_LOSS_OUTOFMIRROR],&norm,normold));
  fprintf(fp,"  e-beam cut out ...............: (left: %6d) %e\n",norm,lossfrac(richLossCounter[PMI_LOSS_EBEAMCUTOUT],&norm,normold));
  fprintf(fp,"  total ........................: (left: %6d) %e\n\n",norm,1.0-double(norm)/double(normold)); 
  normold=norm;
  fprintf(fp,"----------------------------------------------------------------------\n");
  fprintf(fp,"Photon Detector Entry Window .....\n");
  fprintf(fp,"  outside of boundaries ........: (left: %6d) %e\n",norm,lossfrac(richLossCounter[PDW_LOSS_OUTOFBOUNDS],&norm,normold));
  fprintf(fp,"  total ........................: (left: %6d) %e\n\n",norm,1.0-double(norm)/double(normold)); 
  normold=norm;
  fprintf(fp,"----------------------------------------------------------------------\n");
  fprintf(fp,"Dielectrics .....\n");
  fprintf(fp,"  surface reflexions ...........: (left: %6d) %e\n",norm,lossfrac(richLossCounter[DIM_LOSS_REFLEXIONS],&norm,normold));
  fprintf(fp,"  Rayleigh scattering ..........: (left: %6d) %e\n",norm,lossfrac(richLossCounter[DIM_LOSS_RAYLEIGH],&norm,normold));
  fprintf(fp,"  absorption ...................: (left: %6d) %e\n",norm,lossfrac(richLossCounter[DIM_LOSS_ABSORPTION],&norm,normold));
  fprintf(fp,"  total ........................: (left: %6d) %e\n\n",norm,1.0-double(norm)/double(normold)); 
normold=norm;
  fprintf(fp,"  all losses vessel ............: (left: %6d) %e\n\n",norm,1.0-double(norm)/double(norm0)); 
  fprintf(fp,"----------------------------------------------------------------------\n");
  fprintf(fp,"Detector .....\n");
  fprintf(fp,"  out of supermodule coverage ..: (left: %6d) %e\n",norm,lossfrac(richLossCounter[SUP_LOSS_OUTOFAREA],&norm,normold));
  fprintf(fp,"  cell empty ...................: (left: %6d) %e\n",norm,lossfrac(richLossCounter[SUP_LOSS_CELLEMPTY],&norm,normold));
  fprintf(fp,"  lens efficiency wavelength ...: (left: %6d) %e\n",norm,lossfrac(richLossCounter[LEN_LOSS_WAVELENGTH],&norm,normold));
  fprintf(fp,"  lens angular efficiency ......: (left: %6d) %e\n",norm,lossfrac(richLossCounter[LEN_LOSS_ANGULAR],&norm,normold));
  fprintf(fp,"  pm efficiency ................: (left: %6d) %e\n",norm,lossfrac(richLossCounter[PMT_LOSS_EFFICIENCY],&norm,normold));
  fprintf(fp,"  out pmt area .................: (left: %6d) %e\n",norm,lossfrac(richLossCounter[CEL_LOSS_OUTOFPMTAREA],&norm,normold));
  fprintf(fp,"  total ........................: (left: %6d) %e\n\n",norm,1.0-double(norm)/double(normold)); 
  normold=norm;
  fprintf(fp,"----------------------------------------------------------------------\n");
  fprintf(fp,"  all losses ...................: (left: %6d) %e\n\n",normold,1.0-double(norm)/double(norm0));

  }
