*CMZ :          20/05/96  12.58.34  by  Unknown
*-- Author :   T.Lohse
c
c-------------------------------------------------------------
c
c       subroutine:   VTINIT(x,cov,iv,flag)
c
c       input:    x(3)        =  vertex position      R*8
c                 cov(3,3)    =  covariance matrix    R*8
c
c       output:   iv          =  new vertex index     Int
c                 flag        <0 if fail              Int
c
c       action:   adds a new vertex,
c                 fills vertex buffer to prepare Kalman filter
c
c-------------------------------------------------------------
c
      subroutine  VTINIT ( x, cov, iv, flag )

      implicit none

      integer iv
      double precision 
     1   x(3), cov(3,3), covinv(3,3)

      integer flag, ifail

      integer i, j

#include "vt/vtdat.fi"

      flag = -1
      if (nvt.ge.nvtmax)         goto 999

      do  i = 1, 3
        do  j = 1, 3
          covinv(i,j) = cov(i,j)
        enddo
      enddo
      call DSINV(3,covinv,3,ifail)
      if (ifail.eq.-1)           goto 999

      iv  = 1
  100 continue
      if (vtset(iv)) then
        iv = iv + 1
        if ( iv .gt. nvtmax )    goto 999
        goto 100
      endif

      vtset(iv) = .true.
      nvt = nvt + 1

      fit(iv) = 0
      fitm(iv) = 0
      smooth(iv) = 0
      ntr(iv) = 0
      nconst(iv) = 0
      dist(iv) = 0

      do  i = 1, 3
        xvs(i,iv)    = x(i)
        xv(i,iv,0)   = x(i)
        C(i,i,iv,0)  = cov(i,i)
        CINV(i,i,iv,0) = covinv(i,i)
        CS(i,i,iv)   = cov(i,i)
        do  j = i+1, 3
          C(i,j,iv,0) = cov(i,j)
          C(j,i,iv,0) = cov(i,j)
          CS(i,j,iv)  = cov(i,j)
          CS(j,i,iv)  = cov(i,j)
          CINV(i,j,iv,0) = covinv(i,j)
          CINV(j,i,iv,0) = covinv(i,j)
        enddo
      enddo

      flag = 0

999   continue

      return
      end
